/* 
   - The contents of this file are subject to the Mozilla Public
   - License Version 1.1 (the "License"); you may not use this file
   - except in compliance with the License. You may obtain a copy of
   - the License at http://www.mozilla.org/MPL/
   -
   - Software distributed under the License is distributed on an "AS
   - IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
   - implied. See the License for the specific language governing
   - rights and limitations under the License.
   -
   - The Original Code is this file as it was released on
   - April 1, 2001.
   -
   - The Initial Developer of the Original Code is Henk-Johan van Rantwijk.
   - Portions created by Henk-Johan van Rantwijk are Copyright (C) 2001-2004
   - Henk-Johan van Rantwijk.  All Rights Reserved.
   -
*/

//////////////////////////////////////////////////////////////////////////
function spoofReferrer(url, referrer)
{
  var spoofURL = "http://ref.spoof.org/refspoof.cgi"; // default fake referrer
  var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
  var spoofing = readMyPref("multizilla.refspoof.spoofing", "int", 1);
  switch (spoofing) {
    case 1: // send original referrer
      referrer = getDocumentReferrer(document);
    case 2: // send url as referrer
      spoofURL = url;
      try {
        referrer = ioService.newURI(spoofURL, null, null);
      } catch(ex) {
      }
      break;
    default: // send fake referrer
      try {
        /* spoofURL = pref.getComplexValue("multizilla.refspoof.spoofurl",
                                        Components.interfaces.nsIPrefLocalizedString).data; */
        spoofURL = readMyPref("multizilla.refspoof.spoofurl", "string", spoofURL);
      } catch (ex) {
      }
      referrer = ioService.newURI(spoofURL, null, null);
  }
  return(referrer);
}
//////////////////////////////////////////////////////////////////////////
function getDocumentReferrer(doc)
{
  var focusedWindow = doc.commandDispatcher.focusedWindow;
  var sourceURL = null; 
  /* var sourceURL = isDocumentFrame(focusedWindow) ? focusedWindow.location.href : 
                                                  focusedWindow._content.location.href;
  var sourceURL = isContentFrame(focusedWindow) ? Components.lookupMethod(focusedWindow, 'location').call(focusedWindow).href : 
                                                  window.content; */
  // XXX: This check can be removed when mozilla bug 173703 has been fixed!
  if (focusedWindow)
    sourceURL = getContentFrameURI(focusedWindow);
  else 
    sourceURL = window.content;
  try {
    var uri = Components.classes["@mozilla.org/network/standard-url;1"]
                        .createInstance(Components.interfaces.nsIURI);
    uri.spec = sourceURL;
    return uri;
  } catch (ex) {
    return null;
  }
}
//////////////////////////////////////////////////////////////////////////
// this is a changed function (contentAreaUtils.js) to make spoofing work
//////////////////////////////////////////////////////////////////////////
function getReferrer(doc)
{
  var spoofing = readMyPref("multizilla.refspoof.spoofing", "int", 3);
  if (spoofing == 1)
    return(getDocumentReferrer(doc));
  var focusedWindow = doc.commandDispatcher.focusedWindow;
  var sourceURL = getContentFrameURI(focusedWindow);
  return(spoofReferrer(sourceURL, getDocumentReferrer(document)));
}
//////////////////////////////////////////////////////////////////////////
function loadURI(url, referrer)
{
  if (referrer)
    referrer = spoofReferrer(url, null);
  else referrer = null;
  try {
    getWebNavigation().loadURI(url, nsIWebNavigation.LOAD_FLAGS_NONE, referrer, null, null);
  } catch (ex) {
    // dump('\nMZ error: loadURI("'+url+'") failed');
  }
}